-- Copyright (C) 2012 Jared Krinke.
-- 
-- This is free software; you can redistribute it and/or
-- modify it under the terms of the GNU General Public License
-- as published by the Free Software Foundation; either version 2
-- of the License, or (at your option) any later version.
-- 
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
-- 
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

require("UI/UI.lua")

InstructionsMenu = { }

function InstructionsMenu.new()
    -- Story
    local storyForm = Form.newGrid(1, -300, 200, 600)

    -- Activate/cancel exit
    local storyTitle = Title.new("Prologue")

    storyTitle.getActive = nil

    function storyTitle.inputReceived(self, event, pressed)
        if pressed then
            if event == "activate" then
                Layers.pop()
                return true
            end
        end

        return false
    end

    storyForm:add(storyTitle)

    storyForm:add(Separator.new())
    storyForm:add(Label.new("You are the master architect Daedalus."))
    storyForm:add(Separator.new())
    --                                                       Labyrinth|
    storyForm:add(Label.new("You have just finished building the"))
    storyForm:add(Label.new("Labyrinth; a massive, elaborate maze on"))
    storyForm:add(Label.new("the Isle of Crete."))
    storyForm:add(Separator.new())
    storyForm:add(Label.new("Unfortunately, boasts about your"))
    storyForm:add(Label.new("accomplishment have drawn the wrath of"))
    storyForm:add(Label.new("jealous gods. They have sent a burning"))
    storyForm:add(Label.new("energy wave rippling through your"))
    storyForm:add(Label.new("creation..."))

    local storyMenu = FormLayer.new(storyForm)

    -- Instructions
    local instructionsForm = Form.newGrid(1, -300, 200, 600)

    -- Activate/cancel exit
    local instructionsTitle = Title.new("How to Play")

    instructionsTitle.getActive = nil
    instructionsTitle.inputReceived = storyTitle.inputReceived

    instructionsForm:add(instructionsTitle)

    instructionsForm:add(Separator.new())
    instructionsForm:add(Label.new("Move using the arrow keys."))
    instructionsForm:add(Separator.new())
    instructionsForm:add(Label.new("Try to escape the maze by heading to"))
    instructionsForm:add(Label.new("the right. The farther you make it, the"))
    instructionsForm:add(Label.new("higher your score!"))
    instructionsForm:add(Separator.new())
    instructionsForm:add(Label.new("You lose when the red energy wave sweeps"))
    instructionsForm:add(Label.new("over you."))

    local instructionsMenu = FormLayer.new(instructionsForm)
    local showBase = instructionsMenu.show

    function instructionsMenu.show(self)
        showBase(self)
        storyMenu:show()
    end

    return instructionsMenu
end

