-- Copyright (C) 2012 Jared Krinke.
-- 
-- This is free software; you can redistribute it and/or
-- modify it under the terms of the GNU General Public License
-- as published by the Free Software Foundation; either version 2
-- of the License, or (at your option) any later version.
-- 
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
-- 
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

require("UI/UI.lua")
require("Menus/ControlsMenu.lua")
require("Menus/VideoMenu.lua")
require("Menus/AudioMenu.lua")

OptionsMenu = { }

function OptionsMenu.new()
    local optionsForm = Form.newGrid(1)

    optionsForm.controlsLayer = ControlsMenu.new()
    optionsForm.videoLayer = VideoMenu.new()
    optionsForm.audioLayer = AudioMenu.new()

    -- UI
    optionsForm:add(Title.new("Options"))

    optionsForm:add(Form.newNestedLeftFlow(1,
        Separator.new(),
        Button.new("Controls", function() optionsForm.controlsLayer:show()  end),
        Button.new("Video Options", function() optionsForm.videoLayer:show()  end),
        Button.new("Audio Options", function() optionsForm.audioLayer:show()  end),
        Separator.new(),
        Button.new("Back", function() Layers.pop() end)))

    return FormLayer.new(optionsForm)
end

