-- Copyright (C) 2012 Jared Krinke.
-- 
-- This is free software; you can redistribute it and/or
-- modify it under the terms of the GNU General Public License
-- as published by the Free Software Foundation; either version 2
-- of the License, or (at your option) any later version.
-- 
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
-- 
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Layers = { }

function Layers.push(layer)
    local shownHandler = layer.shown

    layers:push(layer)

    -- Notify layer that it has been shown
    if isFunction(shownHandler) then
        shownHandler(layer)
    end
end

function Layers.pop()
    local poppedLayer = layers:pop()
    local topLayer = layers:pop()

    -- Notify the top layer that it has been shown
    if not isNil(topLayer) then
        local shownHandler = topLayer.shown

        layers:push(topLayer)

        if isFunction(shownHandler) then
            shownHandler(topLayer)
        end
    end

    return poppedLayer
end

