-- Copyright (C) 2012 Jared Krinke.
-- 
-- This is free software; you can redistribute it and/or
-- modify it under the terms of the GNU General Public License
-- as published by the Free Software Foundation; either version 2
-- of the License, or (at your option) any later version.
-- 
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
-- 
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

List = { }

function List.new()
    local list = { }

    list.count = 0

    function list.add(self, v)
        self.count = self.count + 1
        self[self.count] = v
    end

    function list.get(self, index)
        if index >= 1 and index <= self.count then
            return self[index]
        end

        return nil
    end

    function list.getCount(self)
        return self.count
    end
    
    function list.forEach(self, f)
        local i = 1
    
        while i <= self.count do
            f(self[i])
    
            i = i + 1
        end
    end
    
    function list.remove(self, v)
        local i = 1
    
        while i <= self.count do
            if v == self[i] then
                local j = i
    
                while j <= self.count - 1 do
                    self[j] = self[j + 1]
    
                    j = j + 1
                end
    
                self.count = self.count - 1
                
                break
            end
    
            i = i + 1
        end
    end
    
    function list.clear(self)
        local i = 1
    
        while i <= self.count do
            self[i] = nil
    
            i = i + 1
        end
    
        self.count = 0
    end

    return list
end

