-- Copyright (C) 2012 Jared Krinke.
-- 
-- This is free software; you can redistribute it and/or
-- modify it under the terms of the GNU General Public License
-- as published by the Free Software Foundation; either version 2
-- of the License, or (at your option) any later version.
-- 
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
-- 
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

RingBuffer = { }

function RingBuffer.new(maxLines)
    local ringBuffer = { }

    ringBuffer.head = 0
    ringBuffer.tail = 0
    ringBuffer.count = 0
    ringBuffer.size = maxLines

    function ringBuffer.add(self, value)
        self[self.tail] = value
        self.tail = (self.tail + 1) % self.size
    
        if self.count < self.size then
            self.count = self.count + 1
        else
            self.head = (self.head + 1) % self.size
        end
    end
    
    function ringBuffer.forEach(self, f)
        local i = 0
    
        while i < self.count do
            f(self[(self.head + i) % self.size])
            i = i + 1
        end
    end

    -- TODO: Add get newest/oldest (with offset) functions

    return ringBuffer
end

